- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnStateManip Class Reference

# OpenMayaUI - API module for user interface | FunctionSet classes

Search for all occurrences

## Detailed Description

StateManip function set.

The StateManip allows the user to switch between multiple states. It is drawn as a circle with a notch. Each click on the circle increments the value of the state (modulo the maximum number of states). This manipulator generates an integer value corresponding to the state of the manip.

Examples:

  rotateManip.cpp, and swissArmyManip.cpp.

`#include <MFnStateManip.h>`

Inheritance diagram for MFnStateManip:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnStateManip ()
| Destructor.
| MFnStateManip ()
| Default constructor.
| MFnStateManip (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
| MFnStateManip (const MDagPath &object, MStatus *ret=NULL)
| Constructor.
MObject | create (MStatus *ReturnStatus=NULL)
| Creates a new StateManip.
MObject | create (const MString &manipName, const MString &stateName, MStatus *ReturnStatus=NULL)
| Creates a new StateManip.
MStatus | connectToStatePlug (MPlug &statePlug)
| Connect to the state plug.
MStatus | setInitialState (unsigned int initialState)
| Sets the initial state of the StateManip.
MStatus | setMaxStates (unsigned int numStates)
| Sets the maximum number of states that the StateManip will have.
unsigned int | maxStates (MStatus *ReturnStatus=NULL) const
| Returns the number of maximum states.
unsigned int | state (MStatus *ReturnStatus=NULL) const
| Returns the current state.
unsigned int | positionIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the position of the StateManip.
unsigned int | stateIndex (MStatus *ReturnStatus=NULL) const
| Returns the index of the state.
| MFnStateManip (const MObject &object, MStatus *ret=NULL)
| Constructor.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

~MFnStateManip | ( |  | ) | `[virtual]`

Destructor.

Class destructor.

MFnStateManip | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnStateManip | ( | const MDagPath & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given constant MDagPath object.

Parameters:

  [in] | object | The const MDagPath to attach the function set to
  [out] | ReturnStatus | The return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnStateManip | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kStateManip.

Reimplemented from MFnManip3D.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnStateManip".

Reimplemented from MFnManip3D.

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Creates a new StateManip.

This function set's object is set to be the new manipulator.

This method should only be used to create a non-composite StateManip.

The name that appears in the feedback line is "state"

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Newly created StateManip

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MObject create | ( | const MString & | manipName,
|  | const MString & | stateName,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Creates a new StateManip.

This function set's object is set to be the new manipulator.

This method should only be used to create a non-composite StateManip.

The name that appears in the feedback line is specified by the stateName argument.

Parameters:

  [in] | manipName | Name of the manip for UI purposes.
  [in] | stateName | Label for the state value which appears in the feedback line.
  [out] | ReturnStatus | Status code.

Returns:
  Newly created StateManip

Status Codes:
  - MS::kSuccess Operation successful.
  - MS::kFailure Operation failed.

Reimplemented from MFnDependencyNode.

MStatus connectToStatePlug | ( | MPlug & | statePlug | ) |

Search for all occurrences

Connect to the state plug.

The data type corresponding to the statePlug is a int integer.

Parameters:

  [in] | statePlug | the state plug

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setInitialState | ( | unsigned int | initialState | ) |

Search for all occurrences

Sets the initial state of the StateManip.

Parameters:

  [in] | initialState | initial state of the StateManip

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MStatus setMaxStates | ( | unsigned int | numStates | ) |

Search for all occurrences

Sets the maximum number of states that the StateManip will have.

The default number of maximum states is 4.

Parameters:

  [in] | numStates | the maxiumum number of states

Returns:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int maxStates | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the number of maximum states.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Maximum states

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int state | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the current state.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Current states

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int positionIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the position of the StateManip.

The data type corresponding to this index is MFnNumericData::k3Double.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Position index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

unsigned int stateIndex | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Returns the index of the state.

The data type corresponding to this index is a int integer.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  State index

Status Codes:
  - MS::kSuccess operation successful
  - MS::kFailure operation failed

MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip
MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip MFnStateManip